import java.awt.*;
import javax.swing.*;


public class HistogramPanel extends JPanel {
	private float[] hist;
	private int width;
	private int height;
	
	public HistogramPanel (float[] h) {
		hist = h;
		int l = hist.length;
		width = l + 20;
		height = l + 20;
		
        setBackground (Color.white);
        setPreferredSize (new Dimension(width, height));
	}
	
	public void paintComponent (Graphics page)
	{
		super.paintComponent(page);
		page.setColor(Color.blue);
		float maxval = 0;
		for (int j = 0; j < hist.length; j++) {
			if (hist[j] > maxval)
				maxval = hist[j];			
		}
		for (int i = 0; i < hist.length; i++) {
			int len = Math.round((hist[i]/maxval)*hist.length);
			page.drawLine(i, hist.length, i, hist.length-len);
		}
	}
}