
import java.awt.*;
import java.awt.color.ColorSpace;
import java.awt.image.*;
import java.io.*;

import javax.imageio.*;
import javax.swing.*;
import java.util.Scanner;

public class PS1 {
	
	/**
	 * @param args
	 */
	private static BufferedImage convertToGrayscale(BufferedImage source) { 
	     BufferedImageOp op = new ColorConvertOp(
	       ColorSpace.getInstance(ColorSpace.CS_GRAY), null); 
	     return op.filter(source, null);
	}
	
	private static BufferedImage copyBufferedImage (BufferedImage source) {
		BufferedImage target = new BufferedImage(source.getWidth(), source.getHeight(), source.getType());
		Graphics g = target.getGraphics();
		g.drawImage(source, 0, 0, null);
		return target;
	}

	private static float[] uniformHistogram() {
		float[] h = new float[256];
		// ADD CODE
		return h;
	}
	
	private static float[] histogram (BufferedImage img)
	{

		byte pix[] = new byte[1];
		int pix_int;  
		float[] hist = new float[256];
		
		// Add code to determine histogram.
		// Below is some code that just gives an example of how to access
		// the pixels in an image.
		
		img.getRaster().getDataElements(0, 0, pix);
		pix_int = ((int) pix[0]) & 0xff;
		// & 0xff is there because pixels are stored as signed bytes in 
		// Buffered images.  This extracts the pixel value.
		
		System.out.println("First Pixel Value is: " + pix_int);

		int newval = 255;
		if (newval > 127)
			newval = - (256 - newval);
		pix[0] = (byte) newval;
		img.getRaster().setDataElements(0, 0, pix);	
		// The code above changes the intensity of the pixel located at (0,0)
		// to newval.  It is necessary to convert newval to a signed byte value
		
		img.getRaster().getDataElements(0, 0, pix);
		pix_int = ((int) pix[0]) & 0xff;
		System.out.println("First Pixel Value is now: " + pix_int);
		// See
		
		return hist;
	}
	
private static void specifyHistogram(BufferedImage img, float[] hist) {
	// ADD CODE
}
	
	public static void main(String[] args) {
		final String dir = "c:\\dwj\\matlab\\teach\\CMSC 426\\";
		// Replace with the directory you want to use.
	
		BufferedImage img = null;
		BufferedImage imggray = null;
		BufferedImage imggrayspec = null;
		BufferedImage img2 = null;
		BufferedImage img2gray = null;
		float[] newhist;
		Scanner scan = new Scanner (System.in);
		
		System.out.println ("Enter file name:");
		String fname = scan.nextLine();
		File dirfile = new File(dir + fname);
		
		
		try {
            img = ImageIO.read(dirfile);
        } catch (IOException e) {System.out.println("Image not read");
        }
        imggray = convertToGrayscale(img);
        
        JFrame f = new JFrame("Image");
        f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        f.setPreferredSize(new Dimension (1200, 800));
        
        MyImagePanel panel = new MyImagePanel (imggray,400,400);    

	    float[] hist = histogram(imggray);
	    // HistogramPanel hpanel = new HistogramPanel (hist);
	    // The line above won't work until you generate a histogram.  Uncomment for Problem 1.

	    imggrayspec = copyBufferedImage(imggray);
	    
		System.out.println ("Enter file name or 'uniform':");
		String fname2 = scan.nextLine();
		
		MyImagePanel panel3 = null;
		if (fname2.equals("uniform"))
		    newhist = uniformHistogram();
		else {
			dirfile = new File(dir + fname2);
			try {
	            img2 = ImageIO.read(dirfile);
	        } catch (IOException e) {System.out.println("Image not read");
	        }
	        img2gray = convertToGrayscale(img2);
	        newhist = histogram(img2gray);
	        panel3 = new MyImagePanel (img2, 400, 400);
		}
	    
	    specifyHistogram(imggrayspec, newhist);
	    
	    MyImagePanel panel2 = new MyImagePanel (imggrayspec, 400, 400);
	    float[] histspec = histogram(imggrayspec);
	    // HistogramPanel hpanel2 = new HistogramPanel (histspec);
	    
	    JPanel mainpane = new JPanel();
	    mainpane.setBackground(Color.black);
	    mainpane.add(panel);
	    // mainpane.add(hpanel);  Uncomment for Problem 1.
	    if (!fname2.equals("uniform"))
	    	mainpane.add(panel3);
	    mainpane.add(panel2);
	    // mainpane.add(hpanel2);
	    
	    f.getContentPane().add(mainpane);
	    f.pack();
	    f.setVisible(true);
	   
	    
	    System.out.println ("Enter file name to save in or 'exit':");
		String outfname = scan.nextLine();
		if (!outfname.equals("exit"))
	    try {
	    	Dimension size = mainpane.getSize();
	    	BufferedImage frame_image = (BufferedImage)mainpane.createImage(size.width, size.height);
	        Graphics g = frame_image.getGraphics();
	        mainpane.paint(g);
	        g.dispose();
	        
	        dirfile  = new File(dir + outfname);
	        ImageIO.write(frame_image, "jpeg", dirfile);
	    } catch (IOException e) {
	    	System.out.println("Image not saved");
	    }

	}

}



