
import java.awt.*;
import java.awt.image.*;
import javax.swing.*;


public class MyImagePanel extends JPanel {
	
	private int img_height;
	private int img_width;
	private int width;
	private int height;
	private BufferedImage img = null;
	

	public MyImagePanel (BufferedImage i, int max_height, int max_width)
	{
		float scale;
        img = i;
        
        setBackground (Color.black);
        img_height = img.getHeight();
        img_width = img.getWidth();
        if (img_height <= max_height & img_width <= max_width)
        	scale = 1;
        else
        	scale = Math.min((float) max_height/img_height, (float) max_width/img_width);
        width = (int) Math.floor(scale*img_width);
        height = (int) Math.floor(scale*img_height);
        setPreferredSize (new Dimension(width,height));
	}
	
	public void paintComponent (Graphics page)
	{
		super.paintComponent(page);
		page.drawImage(img, 1, 1, width, height, null);
	}
	
}
	

	
	